#include<iostream>
#include<algorithm>
#include<assert.h>
#include<vector>
#define MAXBITS 60
using namespace std;
long long int comb[MAXBITS+1][MAXBITS+1];
void find_combinations () {
    comb[0][0]=1;
    for (int i=1; i<=MAXBITS; i++) {
        comb[i][0]=1;
        for (int j=1; j<=MAXBITS; j++) {
            comb[i][j]=comb[i-1][j-1]+comb[i-1][j];
        }
    }
}
int k;
long long int find_cnt (long long int to) {
    vector <bool> bits;
    long long int temp=to;
    for (;;) {
        bits.push_back(temp&1);
        temp>>=1;
        if (temp==0) break;
    }
    reverse(bits.begin(),bits.end());
    long long int cnt=0;
    for (int i=1; i<bits.size(); i++) {
        if (bits.size()-i-1>=0) cnt+=comb[bits.size()-i-1][k];
    }
    int zeroes=0;
    for (int i=1; i<bits.size(); i++) {
        if (bits[i]==0) zeroes++;
        else if ((bits.size()-i-1>=0)&&(k-zeroes-1>=0)) cnt+=comb[bits.size()-i-1][k-zeroes-1];
    }
    if (zeroes==k) cnt++;
    return cnt;
}
int main () {
    long long int l,r;
    cin >> l >> r >> k ;
    assert((1<=l)&&(l<=r)&&(r<=1e18));
    assert((k>=0)&&(k<=60));
    find_combinations();
    cout << find_cnt(r)-find_cnt(l-1) ;
    cout << endl ;
    return 0;
}
